/* puzzle-view.c generated by valac 0.46.6, the Vala compiler
 * generated from puzzle-view.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gio/gio.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_PUZZLE_VIEW (puzzle_view_get_type ())
#define PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_VIEW, PuzzleView))
#define PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_VIEW, PuzzleViewClass))
#define IS_PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_VIEW))
#define IS_PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_VIEW))
#define PUZZLE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_VIEW, PuzzleViewClass))

typedef struct _PuzzleView PuzzleView;
typedef struct _PuzzleViewClass PuzzleViewClass;
typedef struct _PuzzleViewPrivate PuzzleViewPrivate;

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
enum  {
	PUZZLE_VIEW_0_PROPERTY,
	PUZZLE_VIEW_PUZZLE_PROPERTY,
	PUZZLE_VIEW_NUM_PROPERTIES
};
static GParamSpec* puzzle_view_properties[PUZZLE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _PuzzlePrivate PuzzlePrivate;

struct _PuzzleView {
	GtkDrawingArea parent_instance;
	PuzzleViewPrivate * priv;
};

struct _PuzzleViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _PuzzleViewPrivate {
	gint render_size;
	gint piece_x;
	gint piece_y;
	gboolean piece_unmoved;
	gchar _piece_id;
	gchar last_piece_id;
	gdouble kx;
	gdouble ky;
	RsvgHandle* tiles_handle;
	GFile* image_file;
	cairo_surface_t* surface;
	Puzzle* _puzzle;
};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gint width;
	gint height;
	gchar* map;
	gint map_length1;
	gchar* move_map;
	gint move_map_length1;
	gchar* orig_map;
	gint orig_map_length1;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint moves;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

static gint PuzzleView_private_offset;
static gpointer puzzle_view_parent_class = NULL;

GType puzzle_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleView, g_object_unref)
GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
#define PUZZLE_VIEW_SPACE_OFFSET 4
#define PUZZLE_VIEW_SPACE_PADDING 5
#define PUZZLE_VIEW_THEME_OVERLAY_SIZE 8
#define PUZZLE_VIEW_THEME_TILE_SEGMENTS 27
#define PUZZLE_VIEW_THEME_TILE_CENTER 14
#define PUZZLE_VIEW_THEME_TILE_SIZE 34
PuzzleView* puzzle_view_new (void);
PuzzleView* puzzle_view_construct (GType object_type);
static void puzzle_view_load_image (PuzzleView* self);
static gboolean puzzle_view_real_draw (GtkWidget* base,
                                cairo_t* cr);
static gint puzzle_view_get_tile_size (PuzzleView* self);
Puzzle* puzzle_view_get_puzzle (PuzzleView* self);
static void puzzle_view_draw_square (PuzzleView* self,
                              cairo_t* cr,
                              gint x,
                              gint y,
                              gdouble kx,
                              gdouble ky);
static gchar puzzle_view_get_piece_id (PuzzleView* self);
gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           gint x,
                           gint y);
gint puzzle_get_piece_nr (Puzzle* self,
                          gint x,
                          gint y);
static gboolean puzzle_view_real_button_press_event (GtkWidget* base,
                                              GdkEventButton* event);
gboolean puzzle_game_over (Puzzle* self);
static void puzzle_view_set_piece_id (PuzzleView* self,
                               gchar value);
static gchar* _vala_array_dup7 (gchar* self,
                         int length);
static gboolean puzzle_view_real_button_release_event (GtkWidget* base,
                                                GdkEventButton* event);
gboolean puzzle_movable (Puzzle* self,
                         gint id);
gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
static gchar* _vala_array_dup8 (gchar* self,
                         int length);
static gchar* _vala_array_dup9 (gchar* self,
                         int length);
static gboolean puzzle_view_real_motion_notify_event (GtkWidget* base,
                                               GdkEventMotion* event);
gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            gint x1,
                            gint y1,
                            gint x2,
                            gint y2);
static void puzzle_view_puzzle_changed_cb (PuzzleView* self);
void puzzle_view_set_puzzle (PuzzleView* self,
                             Puzzle* value);
static void _puzzle_view_puzzle_changed_cb_puzzle_changed (Puzzle* _sender,
                                                    gpointer self);
static void puzzle_view_finalize (GObject * obj);
static void _vala_puzzle_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_puzzle_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
puzzle_view_get_instance_private (PuzzleView* self)
{
	return G_STRUCT_MEMBER_P (self, PuzzleView_private_offset);
}

PuzzleView*
puzzle_view_construct (GType object_type)
{
	PuzzleView * self = NULL;
	self = (PuzzleView*) g_object_new (object_type, NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 250, 250);
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON_RELEASE_MASK));
	puzzle_view_load_image (self);
	return self;
}

PuzzleView*
puzzle_view_new (void)
{
	return puzzle_view_construct (TYPE_PUZZLE_VIEW);
}

static void
puzzle_view_load_image (PuzzleView* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_file_new_for_uri ("resource:///org/gnome/Klotski/ui/assets.svg");
	_g_object_unref0 (self->priv->image_file);
	self->priv->image_file = _tmp0_;
	{
		RsvgHandle* _tmp1_ = NULL;
		GFile* _tmp2_;
		RsvgHandle* _tmp3_;
		RsvgHandle* _tmp4_;
		_tmp2_ = self->priv->image_file;
		_tmp3_ = rsvg_handle_new_from_gfile_sync (_tmp2_, RSVG_HANDLE_FLAGS_NONE, NULL, &_inner_error0_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch7_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (self->priv->tiles_handle);
		self->priv->tiles_handle = _tmp4_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "%s %s\n", "Error in puzzle-view.vala load image:", _tmp7_);
		exit (EXIT_FAILURE);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
puzzle_view_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	PuzzleView * self;
	gint _tmp0_;
	gint _tmp1_;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStyleContext* _tmp19_;
	GdkRGBA fg = {0};
	GtkStyleContext* _tmp20_;
	GdkRGBA _tmp21_ = {0};
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp22_;
	GdkRGBA _tmp23_ = {0};
	GtkStyleContext* _tmp24_;
	GdkRGBA _tmp25_;
	gint width = 0;
	gint height = 0;
	GdkRGBA _tmp26_;
	gdouble kwidth = 0.0;
	Puzzle* _tmp27_;
	Puzzle* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gdouble kheight = 0.0;
	Puzzle* _tmp31_;
	Puzzle* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gboolean result = FALSE;
	self = (PuzzleView*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = puzzle_view_get_tile_size (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != self->priv->render_size) {
		RsvgHandle* _tmp2_;
		gint _tmp14_;
		gint _tmp15_;
		_tmp2_ = self->priv->tiles_handle;
		if (_tmp2_ != NULL) {
			gint height = 0;
			gint _tmp3_;
			gint _tmp4_;
			gint width = 0;
			gint _tmp5_;
			gint _tmp6_;
			cairo_surface_t* _tmp7_;
			cairo_surface_t* _tmp8_;
			cairo_t* c = NULL;
			cairo_surface_t* _tmp9_;
			cairo_t* _tmp10_;
			gdouble sfw = 0.0;
			gdouble sfh = 0.0;
			cairo_t* _tmp11_;
			RsvgHandle* _tmp12_;
			cairo_t* _tmp13_;
			_tmp3_ = puzzle_view_get_tile_size (self);
			_tmp4_ = _tmp3_;
			height = _tmp4_ * 2;
			_tmp5_ = puzzle_view_get_tile_size (self);
			_tmp6_ = _tmp5_;
			width = _tmp6_ * PUZZLE_VIEW_THEME_TILE_SEGMENTS;
			_tmp7_ = cairo_get_target (cr);
			_tmp8_ = cairo_surface_create_similar (_tmp7_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
			_cairo_surface_destroy0 (self->priv->surface);
			self->priv->surface = _tmp8_;
			_tmp9_ = self->priv->surface;
			_tmp10_ = cairo_create (_tmp9_);
			c = _tmp10_;
			sfw = ((gdouble) width) / 918;
			sfh = ((gdouble) height) / 68;
			_tmp11_ = c;
			cairo_scale (_tmp11_, sfw, sfh);
			_tmp12_ = self->priv->tiles_handle;
			_tmp13_ = c;
			rsvg_handle_render_cairo (_tmp12_, _tmp13_);
			_cairo_destroy0 (c);
		}
		_tmp14_ = puzzle_view_get_tile_size (self);
		_tmp15_ = _tmp14_;
		self->priv->render_size = _tmp15_;
	}
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp17_ = _g_object_ref0 (_tmp16_);
	style = _tmp17_;
	_tmp18_ = style;
	gtk_style_context_save (_tmp18_);
	_tmp19_ = style;
	gtk_style_context_set_state (_tmp19_, GTK_STATE_FLAG_NORMAL);
	_tmp20_ = style;
	gtk_style_context_get_color (_tmp20_, GTK_STATE_FLAG_NORMAL, &_tmp21_);
	fg = _tmp21_;
	_tmp22_ = style;
	gtk_style_context_get_background_color (_tmp22_, GTK_STATE_FLAG_NORMAL, &_tmp23_);
	bg = _tmp23_;
	_tmp24_ = style;
	gtk_style_context_restore (_tmp24_);
	_tmp25_ = bg;
	gdk_cairo_set_source_rgba (cr, &_tmp25_);
	cairo_paint (cr);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp26_ = fg;
	gdk_cairo_set_source_rgba (cr, &_tmp26_);
	cairo_set_line_width (cr, 1.0);
	_tmp27_ = puzzle_view_get_puzzle (self);
	_tmp28_ = _tmp27_;
	_tmp29_ = puzzle_view_get_tile_size (self);
	_tmp30_ = _tmp29_;
	kwidth = ((_tmp28_->width * _tmp30_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
	_tmp31_ = puzzle_view_get_puzzle (self);
	_tmp32_ = _tmp31_;
	_tmp33_ = puzzle_view_get_tile_size (self);
	_tmp34_ = _tmp33_;
	kheight = ((_tmp32_->height * _tmp34_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
	self->priv->kx = (width - kwidth) / 2.0;
	self->priv->ky = (height - kheight) / 2.0;
	cairo_rectangle (cr, self->priv->kx, self->priv->ky, kwidth, kheight);
	cairo_stroke (cr);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp35_ = FALSE;
			_tmp35_ = TRUE;
			while (TRUE) {
				Puzzle* _tmp37_;
				Puzzle* _tmp38_;
				if (!_tmp35_) {
					gint _tmp36_;
					_tmp36_ = y;
					y = _tmp36_ + 1;
				}
				_tmp35_ = FALSE;
				_tmp37_ = puzzle_view_get_puzzle (self);
				_tmp38_ = _tmp37_;
				if (!(y < _tmp38_->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp39_ = FALSE;
						_tmp39_ = TRUE;
						while (TRUE) {
							Puzzle* _tmp41_;
							Puzzle* _tmp42_;
							gchar _tmp43_;
							gchar _tmp44_;
							Puzzle* _tmp45_;
							Puzzle* _tmp46_;
							Puzzle* _tmp47_;
							Puzzle* _tmp48_;
							gchar* _tmp49_;
							gint _tmp49__length1;
							if (!_tmp39_) {
								gint _tmp40_;
								_tmp40_ = x;
								x = _tmp40_ + 1;
							}
							_tmp39_ = FALSE;
							_tmp41_ = puzzle_view_get_puzzle (self);
							_tmp42_ = _tmp41_;
							if (!(x < _tmp42_->width)) {
								break;
							}
							puzzle_view_draw_square (self, cr, x, y, self->priv->kx, self->priv->ky);
							_tmp43_ = puzzle_view_get_piece_id (self);
							_tmp44_ = _tmp43_;
							_tmp45_ = puzzle_view_get_puzzle (self);
							_tmp46_ = _tmp45_;
							_tmp47_ = puzzle_view_get_puzzle (self);
							_tmp48_ = _tmp47_;
							_tmp49_ = _tmp48_->map;
							_tmp49__length1 = _tmp48_->map_length1;
							if (_tmp44_ == puzzle_get_piece_id (_tmp46_, _tmp49_, (gint) _tmp49__length1, x, y)) {
								GdkRGBA _tmp50_ = {0};
								gint _tmp51_;
								gint _tmp52_;
								gint _tmp53_;
								gint _tmp54_;
								gint _tmp55_;
								gint _tmp56_;
								gint _tmp57_;
								gint _tmp58_;
								_tmp50_.red = 1.0;
								_tmp50_.green = 1.0;
								_tmp50_.blue = 1.0;
								_tmp50_.alpha = 0.2;
								gdk_cairo_set_source_rgba (cr, &_tmp50_);
								_tmp51_ = puzzle_view_get_tile_size (self);
								_tmp52_ = _tmp51_;
								_tmp53_ = puzzle_view_get_tile_size (self);
								_tmp54_ = _tmp53_;
								_tmp55_ = puzzle_view_get_tile_size (self);
								_tmp56_ = _tmp55_;
								_tmp57_ = puzzle_view_get_tile_size (self);
								_tmp58_ = _tmp57_;
								cairo_rectangle (cr, (x * _tmp52_) + self->priv->kx, (y * _tmp54_) + self->priv->ky, (gdouble) _tmp56_, (gdouble) _tmp58_);
								cairo_fill (cr);
							}
						}
					}
				}
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (style);
	return result;
}

static void
puzzle_view_draw_square (PuzzleView* self,
                         cairo_t* cr,
                         gint x,
                         gint y,
                         gdouble kx,
                         gdouble ky)
{
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GtkStyleContext* _tmp14_;
	GdkRectangle _tmp15_;
	GdkRGBA _tmp16_;
	Puzzle* _tmp17_;
	Puzzle* _tmp18_;
	Puzzle* _tmp19_;
	Puzzle* _tmp20_;
	gchar* _tmp21_;
	gint _tmp21__length1;
	Puzzle* _tmp32_;
	Puzzle* _tmp33_;
	Puzzle* _tmp34_;
	Puzzle* _tmp35_;
	gchar* _tmp36_;
	gint _tmp36__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	memset (&rect, 0, sizeof (GdkRectangle));
	_tmp0_ = puzzle_view_get_tile_size (self);
	_tmp1_ = _tmp0_;
	rect.x = (((x * _tmp1_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) kx)) - 1;
	_tmp2_ = puzzle_view_get_tile_size (self);
	_tmp3_ = _tmp2_;
	rect.y = (((y * _tmp3_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) ky)) - 1;
	_tmp4_ = puzzle_view_get_tile_size (self);
	_tmp5_ = _tmp4_;
	rect.width = _tmp5_;
	_tmp6_ = puzzle_view_get_tile_size (self);
	_tmp7_ = _tmp6_;
	rect.height = _tmp7_;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	style = _tmp9_;
	_tmp10_ = style;
	gtk_style_context_save (_tmp10_);
	_tmp11_ = style;
	gtk_style_context_set_state (_tmp11_, GTK_STATE_FLAG_NORMAL);
	_tmp12_ = style;
	gtk_style_context_get_background_color (_tmp12_, GTK_STATE_FLAG_NORMAL, &_tmp13_);
	bg = _tmp13_;
	_tmp14_ = style;
	gtk_style_context_restore (_tmp14_);
	_tmp15_ = rect;
	gdk_cairo_rectangle (cr, &_tmp15_);
	_tmp16_ = bg;
	gdk_cairo_set_source_rgba (cr, &_tmp16_);
	cairo_fill (cr);
	_tmp17_ = puzzle_view_get_puzzle (self);
	_tmp18_ = _tmp17_;
	_tmp19_ = puzzle_view_get_puzzle (self);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_->map;
	_tmp21__length1 = _tmp20_->map_length1;
	if (puzzle_get_piece_id (_tmp18_, _tmp21_, (gint) _tmp21__length1, x, y) != ' ') {
		GdkRectangle _tmp22_;
		cairo_surface_t* _tmp23_;
		GdkRectangle _tmp24_;
		Puzzle* _tmp25_;
		Puzzle* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GdkRectangle _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		_tmp22_ = rect;
		gdk_cairo_rectangle (cr, &_tmp22_);
		_tmp23_ = self->priv->surface;
		_tmp24_ = rect;
		_tmp25_ = puzzle_view_get_puzzle (self);
		_tmp26_ = _tmp25_;
		_tmp27_ = puzzle_view_get_tile_size (self);
		_tmp28_ = _tmp27_;
		_tmp29_ = rect;
		_tmp30_ = puzzle_view_get_tile_size (self);
		_tmp31_ = _tmp30_;
		cairo_set_source_surface (cr, _tmp23_, (gdouble) (_tmp24_.x - (puzzle_get_piece_nr (_tmp26_, x, y) * _tmp28_)), (gdouble) (_tmp29_.y - (_tmp31_ / 2)));
		cairo_fill (cr);
	}
	_tmp32_ = puzzle_view_get_puzzle (self);
	_tmp33_ = _tmp32_;
	_tmp34_ = puzzle_view_get_puzzle (self);
	_tmp35_ = _tmp34_;
	_tmp36_ = _tmp35_->map;
	_tmp36__length1 = _tmp35_->map_length1;
	if (puzzle_get_piece_id (_tmp33_, _tmp36_, (gint) _tmp36__length1, x, y) == '*') {
		gint value = 0;
		Puzzle* _tmp37_;
		Puzzle* _tmp38_;
		Puzzle* _tmp39_;
		Puzzle* _tmp40_;
		gchar* _tmp41_;
		gint _tmp41__length1;
		gint overlay_size = 0;
		gint _tmp42_;
		gint _tmp43_;
		gint overlay_offset = 0;
		gint _tmp44_;
		gint _tmp45_;
		GdkRectangle _tmp46_;
		GdkRectangle _tmp47_;
		cairo_surface_t* _tmp48_;
		GdkRectangle _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		GdkRectangle _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		value = 22;
		_tmp37_ = puzzle_view_get_puzzle (self);
		_tmp38_ = _tmp37_;
		_tmp39_ = puzzle_view_get_puzzle (self);
		_tmp40_ = _tmp39_;
		_tmp41_ = _tmp40_->orig_map;
		_tmp41__length1 = _tmp40_->orig_map_length1;
		if (puzzle_get_piece_id (_tmp38_, _tmp41_, (gint) _tmp41__length1, x, y) == '.') {
			value = 20;
		}
		_tmp42_ = puzzle_view_get_tile_size (self);
		_tmp43_ = _tmp42_;
		overlay_size = (PUZZLE_VIEW_THEME_OVERLAY_SIZE * _tmp43_) / PUZZLE_VIEW_THEME_TILE_SIZE;
		_tmp44_ = puzzle_view_get_tile_size (self);
		_tmp45_ = _tmp44_;
		overlay_offset = ((PUZZLE_VIEW_THEME_TILE_CENTER * _tmp45_) / PUZZLE_VIEW_THEME_TILE_SIZE) - (overlay_size / 2);
		_tmp46_ = rect;
		_tmp47_ = rect;
		cairo_rectangle (cr, (gdouble) (_tmp46_.x + overlay_offset), (gdouble) (_tmp47_.y + overlay_offset), (gdouble) overlay_size, (gdouble) overlay_size);
		_tmp48_ = self->priv->surface;
		_tmp49_ = rect;
		_tmp50_ = puzzle_view_get_tile_size (self);
		_tmp51_ = _tmp50_;
		_tmp52_ = rect;
		_tmp53_ = puzzle_view_get_tile_size (self);
		_tmp54_ = _tmp53_;
		cairo_set_source_surface (cr, _tmp48_, (gdouble) (_tmp49_.x - (value * _tmp51_)), (gdouble) (_tmp52_.y - (_tmp54_ / 2)));
		cairo_fill (cr);
	}
	_g_object_unref0 (style);
}

static gchar*
_vala_array_dup7 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gboolean
puzzle_view_real_button_press_event (GtkWidget* base,
                                     GdkEventButton* event)
{
	PuzzleView * self;
	gboolean result = FALSE;
	self = (PuzzleView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
		Puzzle* _tmp0_;
		Puzzle* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar new_piece_id = '\0';
		Puzzle* _tmp6_;
		Puzzle* _tmp7_;
		Puzzle* _tmp8_;
		Puzzle* _tmp9_;
		gchar* _tmp10_;
		gint _tmp10__length1;
		gboolean _tmp11_ = FALSE;
		gchar _tmp12_;
		gchar _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		Puzzle* _tmp20_;
		Puzzle* _tmp21_;
		Puzzle* _tmp22_;
		Puzzle* _tmp23_;
		gchar* _tmp24_;
		gint _tmp24__length1;
		gchar* _tmp25_;
		gint _tmp25__length1;
		_tmp0_ = puzzle_view_get_puzzle (self);
		_tmp1_ = _tmp0_;
		if (puzzle_game_over (_tmp1_)) {
			result = FALSE;
			return result;
		}
		_tmp2_ = puzzle_view_get_tile_size (self);
		_tmp3_ = _tmp2_;
		self->priv->piece_x = ((gint) (event->x - self->priv->kx)) / _tmp3_;
		_tmp4_ = puzzle_view_get_tile_size (self);
		_tmp5_ = _tmp4_;
		self->priv->piece_y = ((gint) (event->y - self->priv->ky)) / _tmp5_;
		_tmp6_ = puzzle_view_get_puzzle (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = puzzle_view_get_puzzle (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = _tmp9_->map;
		_tmp10__length1 = _tmp9_->map_length1;
		new_piece_id = puzzle_get_piece_id (_tmp7_, _tmp10_, (gint) _tmp10__length1, self->priv->piece_x, self->priv->piece_y);
		_tmp12_ = puzzle_view_get_piece_id (self);
		_tmp13_ = _tmp12_;
		if (_tmp13_ != '\0') {
			_tmp11_ = self->priv->piece_unmoved;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			puzzle_view_set_piece_id (self, '\0');
			result = FALSE;
			return result;
		}
		if (new_piece_id == ' ') {
			_tmp17_ = TRUE;
		} else {
			_tmp17_ = new_piece_id == '.';
		}
		if (_tmp17_) {
			_tmp16_ = TRUE;
		} else {
			_tmp16_ = new_piece_id == '-';
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			_tmp15_ = new_piece_id == '#';
		}
		if (_tmp15_) {
			_tmp14_ = TRUE;
		} else {
			gchar _tmp18_;
			gchar _tmp19_;
			_tmp18_ = puzzle_view_get_piece_id (self);
			_tmp19_ = _tmp18_;
			_tmp14_ = new_piece_id == _tmp19_;
		}
		if (_tmp14_) {
			result = FALSE;
			return result;
		}
		self->priv->piece_unmoved = TRUE;
		puzzle_view_set_piece_id (self, new_piece_id);
		_tmp20_ = puzzle_view_get_puzzle (self);
		_tmp21_ = _tmp20_;
		_tmp22_ = puzzle_view_get_puzzle (self);
		_tmp23_ = _tmp22_;
		_tmp24_ = _tmp23_->map;
		_tmp24__length1 = _tmp23_->map_length1;
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup7 (_tmp24_, _tmp24__length1) : ((gpointer) _tmp24_);
		_tmp25__length1 = _tmp24__length1;
		_tmp21_->move_map = (g_free (_tmp21_->move_map), NULL);
		_tmp21_->move_map = _tmp25_;
		_tmp21_->move_map_length1 = _tmp25__length1;
	}
	result = FALSE;
	return result;
}

static gchar*
_vala_array_dup8 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gchar*
_vala_array_dup9 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gboolean
puzzle_view_real_button_release_event (GtkWidget* base,
                                       GdkEventButton* event)
{
	PuzzleView * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (PuzzleView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
		gchar _tmp1_;
		gchar _tmp2_;
		_tmp1_ = puzzle_view_get_piece_id (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ != '\0';
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean _tmp3_ = FALSE;
		Puzzle* _tmp4_;
		Puzzle* _tmp5_;
		gchar _tmp6_;
		gchar _tmp7_;
		if (self->priv->piece_unmoved) {
			result = FALSE;
			return result;
		}
		_tmp4_ = puzzle_view_get_puzzle (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = puzzle_view_get_piece_id (self);
		_tmp7_ = _tmp6_;
		if (puzzle_movable (_tmp5_, (gint) _tmp7_)) {
			Puzzle* _tmp8_;
			Puzzle* _tmp9_;
			Puzzle* _tmp10_;
			Puzzle* _tmp11_;
			gchar* _tmp12_;
			gint _tmp12__length1;
			Puzzle* _tmp13_;
			Puzzle* _tmp14_;
			gchar* _tmp15_;
			gint _tmp15__length1;
			_tmp8_ = puzzle_view_get_puzzle (self);
			_tmp9_ = _tmp8_;
			_tmp10_ = puzzle_view_get_puzzle (self);
			_tmp11_ = _tmp10_;
			_tmp12_ = _tmp11_->move_map;
			_tmp12__length1 = _tmp11_->move_map_length1;
			_tmp13_ = puzzle_view_get_puzzle (self);
			_tmp14_ = _tmp13_;
			_tmp15_ = _tmp14_->map;
			_tmp15__length1 = _tmp14_->map_length1;
			_tmp3_ = puzzle_mapcmp (_tmp9_, _tmp12_, (gint) _tmp12__length1, _tmp15_, (gint) _tmp15__length1);
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gboolean _tmp16_ = FALSE;
			gboolean _tmp30_ = FALSE;
			Puzzle* _tmp31_;
			Puzzle* _tmp32_;
			Puzzle* _tmp46_;
			Puzzle* _tmp47_;
			Puzzle* _tmp48_;
			Puzzle* _tmp49_;
			gchar* _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
			gint _tmp51__length1;
			Puzzle* _tmp52_;
			Puzzle* _tmp53_;
			if (self->priv->last_piece_id == '\0') {
				_tmp16_ = TRUE;
			} else {
				gchar _tmp17_;
				gchar _tmp18_;
				_tmp17_ = puzzle_view_get_piece_id (self);
				_tmp18_ = _tmp17_;
				_tmp16_ = self->priv->last_piece_id != _tmp18_;
			}
			if (_tmp16_) {
				Puzzle* _tmp19_;
				Puzzle* _tmp20_;
				Puzzle* _tmp21_;
				Puzzle* _tmp22_;
				gchar* _tmp23_;
				gint _tmp23__length1;
				gchar* _tmp24_;
				gint _tmp24__length1;
				Puzzle* _tmp25_;
				Puzzle* _tmp26_;
				_tmp19_ = puzzle_view_get_puzzle (self);
				_tmp20_ = _tmp19_;
				_tmp21_ = puzzle_view_get_puzzle (self);
				_tmp22_ = _tmp21_;
				_tmp23_ = _tmp22_->lastmove_map;
				_tmp23__length1 = _tmp22_->lastmove_map_length1;
				_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup8 (_tmp23_, _tmp23__length1) : ((gpointer) _tmp23_);
				_tmp24__length1 = _tmp23__length1;
				_tmp20_->undomove_map = (g_free (_tmp20_->undomove_map), NULL);
				_tmp20_->undomove_map = _tmp24_;
				_tmp20_->undomove_map_length1 = _tmp24__length1;
				_tmp25_ = puzzle_view_get_puzzle (self);
				_tmp26_ = _tmp25_;
				if (_tmp26_->moves < 999) {
					Puzzle* _tmp27_;
					Puzzle* _tmp28_;
					gint _tmp29_;
					_tmp27_ = puzzle_view_get_puzzle (self);
					_tmp28_ = _tmp27_;
					_tmp29_ = _tmp28_->moves;
					_tmp28_->moves = _tmp29_ + 1;
				}
			}
			_tmp31_ = puzzle_view_get_puzzle (self);
			_tmp32_ = _tmp31_;
			if (_tmp32_->moves > 0) {
				Puzzle* _tmp33_;
				Puzzle* _tmp34_;
				Puzzle* _tmp35_;
				Puzzle* _tmp36_;
				gchar* _tmp37_;
				gint _tmp37__length1;
				Puzzle* _tmp38_;
				Puzzle* _tmp39_;
				gchar* _tmp40_;
				gint _tmp40__length1;
				_tmp33_ = puzzle_view_get_puzzle (self);
				_tmp34_ = _tmp33_;
				_tmp35_ = puzzle_view_get_puzzle (self);
				_tmp36_ = _tmp35_;
				_tmp37_ = _tmp36_->undomove_map;
				_tmp37__length1 = _tmp36_->undomove_map_length1;
				_tmp38_ = puzzle_view_get_puzzle (self);
				_tmp39_ = _tmp38_;
				_tmp40_ = _tmp39_->map;
				_tmp40__length1 = _tmp39_->map_length1;
				_tmp30_ = !puzzle_mapcmp (_tmp34_, _tmp37_, (gint) _tmp37__length1, _tmp40_, (gint) _tmp40__length1);
			} else {
				_tmp30_ = FALSE;
			}
			if (_tmp30_) {
				Puzzle* _tmp41_;
				Puzzle* _tmp42_;
				gint _tmp43_;
				_tmp41_ = puzzle_view_get_puzzle (self);
				_tmp42_ = _tmp41_;
				_tmp43_ = _tmp42_->moves;
				_tmp42_->moves = _tmp43_ - 1;
				self->priv->last_piece_id = '\0';
			} else {
				gchar _tmp44_;
				gchar _tmp45_;
				_tmp44_ = puzzle_view_get_piece_id (self);
				_tmp45_ = _tmp44_;
				self->priv->last_piece_id = _tmp45_;
			}
			_tmp46_ = puzzle_view_get_puzzle (self);
			_tmp47_ = _tmp46_;
			_tmp48_ = puzzle_view_get_puzzle (self);
			_tmp49_ = _tmp48_;
			_tmp50_ = _tmp49_->map;
			_tmp50__length1 = _tmp49_->map_length1;
			_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup9 (_tmp50_, _tmp50__length1) : ((gpointer) _tmp50_);
			_tmp51__length1 = _tmp50__length1;
			_tmp47_->lastmove_map = (g_free (_tmp47_->lastmove_map), NULL);
			_tmp47_->lastmove_map = _tmp51_;
			_tmp47_->lastmove_map_length1 = _tmp51__length1;
			_tmp52_ = puzzle_view_get_puzzle (self);
			_tmp53_ = _tmp52_;
			g_signal_emit_by_name (_tmp53_, "moved");
		}
		puzzle_view_set_piece_id (self, '\0');
	}
	result = FALSE;
	return result;
}

static gboolean
puzzle_view_real_motion_notify_event (GtkWidget* base,
                                      GdkEventMotion* event)
{
	PuzzleView * self;
	gint new_piece_x = 0;
	gint new_piece_y = 0;
	gchar _tmp0_;
	gchar _tmp1_;
	gboolean result = FALSE;
	self = (PuzzleView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = puzzle_view_get_piece_id (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != '\0') {
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		Puzzle* _tmp9_;
		Puzzle* _tmp10_;
		Puzzle* _tmp13_;
		Puzzle* _tmp14_;
		gchar _tmp15_;
		gchar _tmp16_;
		_tmp2_ = puzzle_view_get_tile_size (self);
		_tmp3_ = _tmp2_;
		new_piece_x = ((gint) (event->x - self->priv->kx)) / _tmp3_;
		_tmp4_ = puzzle_view_get_tile_size (self);
		_tmp5_ = _tmp4_;
		new_piece_y = ((gint) (event->y - self->priv->ky)) / _tmp5_;
		_tmp9_ = puzzle_view_get_puzzle (self);
		_tmp10_ = _tmp9_;
		if (new_piece_x >= _tmp10_->width) {
			_tmp8_ = TRUE;
		} else {
			_tmp8_ = event->x < ((gdouble) 0);
		}
		if (_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			Puzzle* _tmp11_;
			Puzzle* _tmp12_;
			_tmp11_ = puzzle_view_get_puzzle (self);
			_tmp12_ = _tmp11_;
			_tmp7_ = new_piece_y >= _tmp12_->height;
		}
		if (_tmp7_) {
			_tmp6_ = TRUE;
		} else {
			_tmp6_ = event->y < ((gdouble) 0);
		}
		if (_tmp6_) {
			result = FALSE;
			return result;
		}
		_tmp13_ = puzzle_view_get_puzzle (self);
		_tmp14_ = _tmp13_;
		_tmp15_ = puzzle_view_get_piece_id (self);
		_tmp16_ = _tmp15_;
		if (puzzle_move_piece (_tmp14_, _tmp16_, self->priv->piece_x, self->priv->piece_y, new_piece_x, new_piece_y)) {
			self->priv->piece_unmoved = FALSE;
			self->priv->piece_x = new_piece_x;
			self->priv->piece_y = new_piece_y;
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static void
puzzle_view_puzzle_changed_cb (PuzzleView* self)
{
	g_return_if_fail (self != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static gchar
puzzle_view_get_piece_id (PuzzleView* self)
{
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	result = self->priv->_piece_id;
	return result;
}

static void
puzzle_view_set_piece_id (PuzzleView* self,
                          gchar value)
{
	g_return_if_fail (self != NULL);
	self->priv->_piece_id = value;
	gtk_widget_queue_draw ((GtkWidget*) self);
}

Puzzle*
puzzle_view_get_puzzle (PuzzleView* self)
{
	Puzzle* result;
	Puzzle* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_puzzle;
	result = _tmp0_;
	return result;
}

static void
_puzzle_view_puzzle_changed_cb_puzzle_changed (Puzzle* _sender,
                                               gpointer self)
{
	puzzle_view_puzzle_changed_cb ((PuzzleView*) self);
}

void
puzzle_view_set_puzzle (PuzzleView* self,
                        Puzzle* value)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp2_;
	Puzzle* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_puzzle;
	if (_tmp0_ != NULL) {
		Puzzle* _tmp1_;
		_tmp1_ = self->priv->_puzzle;
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
	}
	_tmp2_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_puzzle);
	self->priv->_puzzle = _tmp2_;
	_tmp3_ = self->priv->_puzzle;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _puzzle_view_puzzle_changed_cb_puzzle_changed, self, 0);
	self->priv->piece_x = 0;
	self->priv->piece_y = 0;
	puzzle_view_set_piece_id (self, '\0');
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY]);
}

static gint
puzzle_view_get_tile_size (PuzzleView* self)
{
	gint result;
	gint s = 0;
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	Puzzle* _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = puzzle_view_get_puzzle (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = puzzle_view_get_puzzle (self);
	_tmp3_ = _tmp2_;
	s = MIN ((gtk_widget_get_allocated_width ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp1_->width, (gtk_widget_get_allocated_height ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp3_->height);
	if ((s % 2) != 0) {
		gint _tmp4_;
		_tmp4_ = s;
		s = _tmp4_ - 1;
	}
	result = s;
	return result;
}

static void
puzzle_view_class_init (PuzzleViewClass * klass,
                        gpointer klass_data)
{
	puzzle_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PuzzleView_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) puzzle_view_real_draw;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) puzzle_view_real_button_press_event;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) puzzle_view_real_button_release_event;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) puzzle_view_real_motion_notify_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = puzzle_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_PUZZLE_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY] = g_param_spec_object ("puzzle", "puzzle", "puzzle", TYPE_PUZZLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
puzzle_view_instance_init (PuzzleView * self,
                           gpointer klass)
{
	self->priv = puzzle_view_get_instance_private (self);
	self->priv->render_size = 0;
	self->priv->piece_x = 0;
	self->priv->piece_y = 0;
	self->priv->piece_unmoved = FALSE;
	self->priv->_piece_id = '\0';
	self->priv->last_piece_id = '\0';
	self->priv->kx = (gdouble) 0;
	self->priv->ky = (gdouble) 0;
	self->priv->tiles_handle = NULL;
	self->priv->image_file = NULL;
	self->priv->surface = NULL;
	self->priv->_puzzle = NULL;
}

static void
puzzle_view_finalize (GObject * obj)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
	_g_object_unref0 (self->priv->tiles_handle);
	_g_object_unref0 (self->priv->image_file);
	_cairo_surface_destroy0 (self->priv->surface);
	_g_object_unref0 (self->priv->_puzzle);
	G_OBJECT_CLASS (puzzle_view_parent_class)->finalize (obj);
}

GType
puzzle_view_get_type (void)
{
	static volatile gsize puzzle_view_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PuzzleView), 0, (GInstanceInitFunc) puzzle_view_instance_init, NULL };
		GType puzzle_view_type_id;
		puzzle_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PuzzleView", &g_define_type_info, 0);
		PuzzleView_private_offset = g_type_add_instance_private (puzzle_view_type_id, sizeof (PuzzleViewPrivate));
		g_once_init_leave (&puzzle_view_type_id__volatile, puzzle_view_type_id);
	}
	return puzzle_view_type_id__volatile;
}

static void
_vala_puzzle_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
	switch (property_id) {
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
		g_value_set_object (value, puzzle_view_get_puzzle (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_puzzle_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
	switch (property_id) {
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
		puzzle_view_set_puzzle (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

