/* puzzle.c generated by valac 0.46.6, the Vala compiler
 * generated from puzzle.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*
  1   2   4

  8   *   16

  32  64  128
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
typedef struct _PuzzlePrivate PuzzlePrivate;
enum  {
	PUZZLE_0_PROPERTY,
	PUZZLE_NUM_PROPERTIES
};
static GParamSpec* puzzle_properties[PUZZLE_NUM_PROPERTIES];
enum  {
	PUZZLE_CHANGED_SIGNAL,
	PUZZLE_MOVED_SIGNAL,
	PUZZLE_NUM_SIGNALS
};
static guint puzzle_signals[PUZZLE_NUM_SIGNALS] = {0};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gint width;
	gint height;
	gchar* map;
	gint map_length1;
	gchar* move_map;
	gint move_map_length1;
	gchar* orig_map;
	gint orig_map_length1;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint moves;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

static gpointer puzzle_parent_class = NULL;

GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
Puzzle* puzzle_new (gint width,
                    gint height,
                    const gchar* data);
Puzzle* puzzle_construct (GType object_type,
                          gint width,
                          gint height,
                          const gchar* data);
static gchar* _vala_array_dup1 (gchar* self,
                         int length);
static gchar* _vala_array_dup2 (gchar* self,
                         int length);
static void puzzle_set_piece_id (Puzzle* self,
                          gchar* src,
                          gint src_length1,
                          gint x,
                          gint y,
                          gchar id);
static gchar* _vala_array_dup3 (gchar* self,
                         int length);
static gchar* _vala_array_dup4 (gchar* self,
                         int length);
gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           gint x,
                           gint y);
gint puzzle_get_piece_nr (Puzzle* self,
                          gint x,
                          gint y);
gboolean puzzle_game_over (Puzzle* self);
gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
gboolean puzzle_movable (Puzzle* self,
                         gint id);
gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            gint x1,
                            gint y1,
                            gint x2,
                            gint y2);
static gboolean puzzle_check_valid_move (Puzzle* self,
                                  gint id,
                                  gint dx,
                                  gint dy);
static gboolean puzzle_do_move_piece (Puzzle* self,
                               gchar id,
                               gint dx,
                               gint dy);
static gchar* _vala_array_dup5 (gchar* self,
                         int length);
static gchar* _vala_array_dup6 (gchar* self,
                         int length);
static void puzzle_finalize (GObject * obj);

const gint image_map[110] = {0, 0, 64, 1, 66, 2, 2, 3, 16, 4, 24, 5, 8, 6, 208, 7, 248, 8, 104, 9, 214, 10, 255, 11, 107, 12, 22, 13, 31, 14, 11, 15, 18, 16, 10, 17, 80, 18, 72, 19, 56, 5, 152, 5, 70, 2, 67, 2, 194, 2, 98, 2, 9, 6, 20, 4, 144, 4, 3, 3, 40, 6, 25, 5, 28, 5, 96, 1, 19, 16, 201, 19, 146, 16, 198, 2, 84, 18, 46, 17, 112, 18, 6, 3, 184, 5, 192, 1, 147, 16, 73, 19, 42, 17, 200, 19, 99, 2, 116, 18, 29, 5, 14, 17, 26, 25, 224, 1, -1, -1};

static gchar*
_vala_array_dup1 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gchar*
_vala_array_dup2 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
_vala_array_dup3 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gchar*
_vala_array_dup4 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

Puzzle*
puzzle_construct (GType object_type,
                  gint width,
                  gint height,
                  const gchar* data)
{
	Puzzle * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gint _tmp14__length1;
	self = (Puzzle*) g_object_new (object_type, NULL);
	self->width = width;
	self->height = height;
	_tmp0_ = g_new0 (gchar, (width + 2) * (height + 2));
	self->map = (g_free (self->map), NULL);
	self->map = _tmp0_;
	self->map_length1 = (width + 2) * (height + 2);
	_tmp1_ = self->map;
	_tmp1__length1 = self->map_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	self->move_map = (g_free (self->move_map), NULL);
	self->move_map = _tmp2_;
	self->move_map_length1 = _tmp2__length1;
	_tmp3_ = self->map;
	_tmp3__length1 = self->map_length1;
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup2 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
	_tmp4__length1 = _tmp3__length1;
	self->undomove_map = (g_free (self->undomove_map), NULL);
	self->undomove_map = _tmp4_;
	self->undomove_map_length1 = _tmp4__length1;
	if (data != NULL) {
		gint i = 0;
		i = 0;
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp5_ = FALSE;
				_tmp5_ = TRUE;
				while (TRUE) {
					if (!_tmp5_) {
						gint _tmp6_;
						_tmp6_ = y;
						y = _tmp6_ + 1;
					}
					_tmp5_ = FALSE;
					if (!(y < height)) {
						break;
					}
					{
						gint x = 0;
						x = 0;
						{
							gboolean _tmp7_ = FALSE;
							_tmp7_ = TRUE;
							while (TRUE) {
								gchar* _tmp9_;
								gint _tmp9__length1;
								gint _tmp10_;
								if (!_tmp7_) {
									gint _tmp8_;
									_tmp8_ = x;
									x = _tmp8_ + 1;
								}
								_tmp7_ = FALSE;
								if (!(x < width)) {
									break;
								}
								_tmp9_ = self->map;
								_tmp9__length1 = self->map_length1;
								puzzle_set_piece_id (self, _tmp9_, (gint) _tmp9__length1, x, y, string_get (data, (glong) i));
								_tmp10_ = i;
								i = _tmp10_ + 1;
							}
						}
					}
				}
			}
		}
	}
	_tmp11_ = self->map;
	_tmp11__length1 = self->map_length1;
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup3 (_tmp11_, _tmp11__length1) : ((gpointer) _tmp11_);
	_tmp12__length1 = _tmp11__length1;
	self->orig_map = (g_free (self->orig_map), NULL);
	self->orig_map = _tmp12_;
	self->orig_map_length1 = _tmp12__length1;
	_tmp13_ = self->map;
	_tmp13__length1 = self->map_length1;
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup4 (_tmp13_, _tmp13__length1) : ((gpointer) _tmp13_);
	_tmp14__length1 = _tmp13__length1;
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
	self->lastmove_map = _tmp14_;
	self->lastmove_map_length1 = _tmp14__length1;
	return self;
}

Puzzle*
puzzle_new (gint width,
            gint height,
            const gchar* data)
{
	return puzzle_construct (TYPE_PUZZLE, width, height, data);
}

gchar
puzzle_get_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     gint x,
                     gint y)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = src[(x + 1) + ((y + 1) * (self->width + 2))];
	result = _tmp0_;
	return result;
}

static void
puzzle_set_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     gint x,
                     gint y,
                     gchar id)
{
	g_return_if_fail (self != NULL);
	src[(x + 1) + ((y + 1) * (self->width + 2))] = id;
}

gint
puzzle_get_piece_nr (Puzzle* self,
                     gint x,
                     gint y)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar c = '\0';
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar _tmp3_;
	gint nr = 0;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar _tmp5_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	gchar _tmp7_;
	gchar* _tmp8_;
	gint _tmp8__length1;
	gchar _tmp9_;
	gchar* _tmp10_;
	gint _tmp10__length1;
	gchar _tmp11_;
	gchar* _tmp12_;
	gint _tmp12__length1;
	gchar _tmp13_;
	gchar* _tmp14_;
	gint _tmp14__length1;
	gchar _tmp15_;
	gchar* _tmp16_;
	gint _tmp16__length1;
	gchar _tmp17_;
	gchar* _tmp18_;
	gint _tmp18__length1;
	gchar _tmp19_;
	gint i = 0;
	gint _tmp23_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = x;
	x = _tmp0_ + 1;
	_tmp1_ = y;
	y = _tmp1_ + 1;
	_tmp2_ = self->map;
	_tmp2__length1 = self->map_length1;
	_tmp3_ = _tmp2_[x + (y * (self->width + 2))];
	c = _tmp3_;
	if (c == '-') {
		result = 23;
		return result;
	}
	if (c == ' ') {
		result = 21;
		return result;
	}
	if (c == '.') {
		result = 20;
		return result;
	}
	nr = 0;
	_tmp4_ = self->map;
	_tmp4__length1 = self->map_length1;
	_tmp5_ = _tmp4_[(x - 1) + ((y - 1) * (self->width + 2))];
	if (_tmp5_ == c) {
		nr += 1;
	}
	_tmp6_ = self->map;
	_tmp6__length1 = self->map_length1;
	_tmp7_ = _tmp6_[(x - 0) + ((y - 1) * (self->width + 2))];
	if (_tmp7_ == c) {
		nr += 2;
	}
	_tmp8_ = self->map;
	_tmp8__length1 = self->map_length1;
	_tmp9_ = _tmp8_[(x + 1) + ((y - 1) * (self->width + 2))];
	if (_tmp9_ == c) {
		nr += 4;
	}
	_tmp10_ = self->map;
	_tmp10__length1 = self->map_length1;
	_tmp11_ = _tmp10_[(x - 1) + ((y - 0) * (self->width + 2))];
	if (_tmp11_ == c) {
		nr += 8;
	}
	_tmp12_ = self->map;
	_tmp12__length1 = self->map_length1;
	_tmp13_ = _tmp12_[(x + 1) + ((y - 0) * (self->width + 2))];
	if (_tmp13_ == c) {
		nr += 16;
	}
	_tmp14_ = self->map;
	_tmp14__length1 = self->map_length1;
	_tmp15_ = _tmp14_[(x - 1) + ((y + 1) * (self->width + 2))];
	if (_tmp15_ == c) {
		nr += 32;
	}
	_tmp16_ = self->map;
	_tmp16__length1 = self->map_length1;
	_tmp17_ = _tmp16_[(x - 0) + ((y + 1) * (self->width + 2))];
	if (_tmp17_ == c) {
		nr += 64;
	}
	_tmp18_ = self->map;
	_tmp18__length1 = self->map_length1;
	_tmp19_ = _tmp18_[(x + 1) + ((y + 1) * (self->width + 2))];
	if (_tmp19_ == c) {
		nr += 128;
	}
	i = 0;
	while (TRUE) {
		gboolean _tmp20_ = FALSE;
		gint _tmp21_;
		_tmp21_ = image_map[i];
		if (nr != _tmp21_) {
			gint _tmp22_;
			_tmp22_ = image_map[i];
			_tmp20_ = _tmp22_ != -1;
		} else {
			_tmp20_ = FALSE;
		}
		if (!_tmp20_) {
			break;
		}
		i += 2;
	}
	_tmp23_ = image_map[i + 1];
	result = _tmp23_;
	return result;
}

gboolean
puzzle_game_over (Puzzle* self)
{
	gboolean over = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	over = TRUE;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gboolean _tmp4_ = FALSE;
							gchar* _tmp5_;
							gint _tmp5__length1;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = x;
								x = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							_tmp5_ = self->map;
							_tmp5__length1 = self->map_length1;
							if (puzzle_get_piece_id (self, _tmp5_, (gint) _tmp5__length1, x, y) == '*') {
								gchar* _tmp6_;
								gint _tmp6__length1;
								_tmp6_ = self->orig_map;
								_tmp6__length1 = self->orig_map_length1;
								_tmp4_ = puzzle_get_piece_id (self, _tmp6_, (gint) _tmp6__length1, x, y) != '.';
							} else {
								_tmp4_ = FALSE;
							}
							if (_tmp4_) {
								over = FALSE;
							}
						}
					}
				}
			}
		}
	}
	result = over;
	return result;
}

gboolean
puzzle_mapcmp (Puzzle* self,
               gchar* m1,
               gint m1_length1,
               gchar* m2,
               gint m2_length1)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = x;
								x = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							if (puzzle_get_piece_id (self, m1, (gint) m1_length1, x, y) != puzzle_get_piece_id (self, m2, (gint) m2_length1, x, y)) {
								result = TRUE;
								return result;
							}
						}
					}
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
puzzle_movable (Puzzle* self,
                gint id)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (id == ((gint) '#')) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = id == ((gint) '.');
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = id == ((gint) ' ');
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = id == ((gint) '-');
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

gboolean
puzzle_move_piece (Puzzle* self,
                   gchar id,
                   gint x1,
                   gint y1,
                   gint x2,
                   gint y2)
{
	gboolean return_value = FALSE;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	return_value = FALSE;
	if (!puzzle_movable (self, (gint) id)) {
		result = FALSE;
		return result;
	}
	_tmp0_ = self->map;
	_tmp0__length1 = self->map_length1;
	if (puzzle_get_piece_id (self, _tmp0_, (gint) _tmp0__length1, x2, y2) == id) {
		return_value = TRUE;
	}
	if (y1 == y2) {
		_tmp2_ = abs (x1 - x2) == 1;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_ = FALSE;
		if (x1 == x2) {
			_tmp3_ = abs (y1 - y2) == 1;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp1_ = _tmp3_;
	}
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	if (abs (y1 - y2) == 1) {
		if ((y1 - y2) < 0) {
			if (puzzle_check_valid_move (self, (gint) id, 0, 1)) {
				result = puzzle_do_move_piece (self, id, 0, 1);
				return result;
			}
		}
		if ((y1 - y2) > 0) {
			if (puzzle_check_valid_move (self, (gint) id, 0, -1)) {
				result = puzzle_do_move_piece (self, id, 0, -1);
				return result;
			}
		}
	}
	if (abs (x1 - x2) == 1) {
		if ((x1 - x2) < 0) {
			if (puzzle_check_valid_move (self, (gint) id, 1, 0)) {
				result = puzzle_do_move_piece (self, id, 1, 0);
				return result;
			}
		}
		if ((x1 - x2) > 0) {
			if (puzzle_check_valid_move (self, (gint) id, -1, 0)) {
				result = puzzle_do_move_piece (self, id, -1, 0);
				return result;
			}
		}
	}
	result = return_value;
	return result;
}

static gboolean
puzzle_check_valid_move (Puzzle* self,
                         gint id,
                         gint dx,
                         gint dy)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gchar* _tmp4_;
							gint _tmp4__length1;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = x;
								x = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							_tmp4_ = self->map;
							_tmp4__length1 = self->map_length1;
							if (((gint) puzzle_get_piece_id (self, _tmp4_, (gint) _tmp4__length1, x, y)) == id) {
								gchar z = '\0';
								gchar* _tmp5_;
								gint _tmp5__length1;
								gboolean _tmp6_ = FALSE;
								gboolean _tmp7_ = FALSE;
								gboolean _tmp8_ = FALSE;
								_tmp5_ = self->map;
								_tmp5__length1 = self->map_length1;
								z = puzzle_get_piece_id (self, _tmp5_, (gint) _tmp5__length1, x + dx, y + dy);
								if (z == ' ') {
									_tmp8_ = TRUE;
								} else {
									_tmp8_ = z == '.';
								}
								if (_tmp8_) {
									_tmp7_ = TRUE;
								} else {
									_tmp7_ = ((gint) z) == id;
								}
								if (_tmp7_) {
									_tmp6_ = TRUE;
								} else {
									gboolean _tmp9_ = FALSE;
									if (id == ((gint) '*')) {
										_tmp9_ = z == '-';
									} else {
										_tmp9_ = FALSE;
									}
									_tmp6_ = _tmp9_;
								}
								if (!_tmp6_) {
									result = FALSE;
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static gchar*
_vala_array_dup5 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gchar*
_vala_array_dup6 (gchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gchar));
}

static gboolean
puzzle_do_move_piece (Puzzle* self,
                      gchar id,
                      gint dx,
                      gint dy)
{
	gchar* tmpmap = NULL;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint tmpmap_length1;
	gint _tmpmap_size_;
	gchar* _tmp26_;
	gint _tmp26__length1;
	gchar* _tmp27_;
	gint _tmp27__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->map;
	_tmp0__length1 = self->map_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup5 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	tmpmap = _tmp1_;
	tmpmap_length1 = _tmp1__length1;
	_tmpmap_size_ = tmpmap_length1;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = y;
					y = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gchar* _tmp6_;
							gint _tmp6__length1;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = x;
								x = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							_tmp6_ = tmpmap;
							_tmp6__length1 = tmpmap_length1;
							if (puzzle_get_piece_id (self, _tmp6_, (gint) _tmp6__length1, x, y) == id) {
								gchar* _tmp7_;
								gint _tmp7__length1;
								_tmp7_ = tmpmap;
								_tmp7__length1 = tmpmap_length1;
								puzzle_set_piece_id (self, _tmp7_, (gint) _tmp7__length1, x, y, ' ');
							}
						}
					}
				}
			}
		}
	}
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = y;
					y = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							gchar* _tmp12_;
							gint _tmp12__length1;
							if (!_tmp10_) {
								gint _tmp11_;
								_tmp11_ = x;
								x = _tmp11_ + 1;
							}
							_tmp10_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							_tmp12_ = self->map;
							_tmp12__length1 = self->map_length1;
							if (puzzle_get_piece_id (self, _tmp12_, (gint) _tmp12__length1, x, y) == id) {
								gchar* _tmp13_;
								gint _tmp13__length1;
								_tmp13_ = tmpmap;
								_tmp13__length1 = tmpmap_length1;
								puzzle_set_piece_id (self, _tmp13_, (gint) _tmp13__length1, x + dx, y + dy, id);
							}
						}
					}
				}
			}
		}
	}
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = y;
					y = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				if (!(y < self->height)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							gboolean _tmp18_ = FALSE;
							gchar* _tmp19_;
							gint _tmp19__length1;
							gboolean _tmp22_ = FALSE;
							gchar* _tmp23_;
							gint _tmp23__length1;
							if (!_tmp16_) {
								gint _tmp17_;
								_tmp17_ = x;
								x = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							if (!(x < self->width)) {
								break;
							}
							_tmp19_ = tmpmap;
							_tmp19__length1 = tmpmap_length1;
							if (puzzle_get_piece_id (self, _tmp19_, (gint) _tmp19__length1, x, y) == ' ') {
								gchar* _tmp20_;
								gint _tmp20__length1;
								_tmp20_ = self->orig_map;
								_tmp20__length1 = self->orig_map_length1;
								_tmp18_ = puzzle_get_piece_id (self, _tmp20_, (gint) _tmp20__length1, x, y) == '.';
							} else {
								_tmp18_ = FALSE;
							}
							if (_tmp18_) {
								gchar* _tmp21_;
								gint _tmp21__length1;
								_tmp21_ = tmpmap;
								_tmp21__length1 = tmpmap_length1;
								puzzle_set_piece_id (self, _tmp21_, (gint) _tmp21__length1, x, y, '.');
							}
							_tmp23_ = tmpmap;
							_tmp23__length1 = tmpmap_length1;
							if (puzzle_get_piece_id (self, _tmp23_, (gint) _tmp23__length1, x, y) == ' ') {
								gchar* _tmp24_;
								gint _tmp24__length1;
								_tmp24_ = self->orig_map;
								_tmp24__length1 = self->orig_map_length1;
								_tmp22_ = puzzle_get_piece_id (self, _tmp24_, (gint) _tmp24__length1, x, y) == '-';
							} else {
								_tmp22_ = FALSE;
							}
							if (_tmp22_) {
								gchar* _tmp25_;
								gint _tmp25__length1;
								_tmp25_ = tmpmap;
								_tmp25__length1 = tmpmap_length1;
								puzzle_set_piece_id (self, _tmp25_, (gint) _tmp25__length1, x, y, '-');
							}
						}
					}
				}
			}
		}
	}
	g_signal_emit (self, puzzle_signals[PUZZLE_CHANGED_SIGNAL], 0);
	_tmp26_ = tmpmap;
	_tmp26__length1 = tmpmap_length1;
	_tmp27_ = (_tmp26_ != NULL) ? _vala_array_dup6 (_tmp26_, _tmp26__length1) : ((gpointer) _tmp26_);
	_tmp27__length1 = _tmp26__length1;
	self->map = (g_free (self->map), NULL);
	self->map = _tmp27_;
	self->map_length1 = _tmp27__length1;
	result = TRUE;
	tmpmap = (g_free (tmpmap), NULL);
	return result;
}

static void
puzzle_class_init (PuzzleClass * klass,
                   gpointer klass_data)
{
	puzzle_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = puzzle_finalize;
	puzzle_signals[PUZZLE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	puzzle_signals[PUZZLE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
puzzle_instance_init (Puzzle * self,
                      gpointer klass)
{
	self->moves = 0;
}

static void
puzzle_finalize (GObject * obj)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
	self->map = (g_free (self->map), NULL);
	self->move_map = (g_free (self->move_map), NULL);
	self->orig_map = (g_free (self->orig_map), NULL);
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
	self->undomove_map = (g_free (self->undomove_map), NULL);
	G_OBJECT_CLASS (puzzle_parent_class)->finalize (obj);
}

GType
puzzle_get_type (void)
{
	static volatile gsize puzzle_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Puzzle), 0, (GInstanceInitFunc) puzzle_instance_init, NULL };
		GType puzzle_type_id;
		puzzle_type_id = g_type_register_static (G_TYPE_OBJECT, "Puzzle", &g_define_type_info, 0);
		g_once_init_leave (&puzzle_type_id__volatile, puzzle_type_id);
	}
	return puzzle_type_id__volatile;
}

